From ef0a72990243c24a2f65b61758181ec9bdee4492 Mon Sep 17 00:00:00 2001
From: Lin Bai <lbai@codeaurora.org>
Date: Tue, 5 Mar 2019 13:58:16 +0800
Subject: [PATCH 09/14] mhi: porting fix from MSM to fix FW dump failure issue

1. gerrit#2559248
2. gerrit#2559249
3. gerrit#2559251
4. gerrit#2559252
---
 mhi/mhi_bhi.c | 69 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 mhi/mhi_isr.c | 12 +++++++++++
 mhi/mhi_pm.c  | 36 +++++++++++++++++++++++++++++++
 3 files changed, 117 insertions(+)

diff --git a/mhi/mhi_bhi.c b/mhi/mhi_bhi.c
index 2f6f3f3..17aa3d5 100755
--- a/mhi/mhi_bhi.c
+++ b/mhi/mhi_bhi.c
@@ -290,6 +290,7 @@ int bhi_rddm(struct mhi_device_ctxt *mhi_dev_ctxt, bool in_panic)
 		TO_MHI_STATE_STR(mhi_dev_ctxt->mhi_state));
 
 #ifndef CONFIG_CNSS_QCA6390
+	/* Patch from MSM gerrit#2559251 */
 	if (!MHI_REG_ACCESS_VALID(mhi_dev_ctxt->mhi_pm_state)) {
 		mhi_log(mhi_dev_ctxt, MHI_MSG_ERROR,
 			"Register access not allowed\n");
@@ -332,6 +333,34 @@ int bhi_rddm(struct mhi_device_ctxt *mhi_dev_ctxt, bool in_panic)
 		"Triggering Device into RDDM mode\n");
 	mhi_set_m_state(mhi_dev_ctxt, MHI_STATE_SYS_ERR);
 
+#ifdef CONFIG_CNSS_QCA6390
+{
+	/* Patch from MSM gerrit#2559249 */
+	int rddm_retry = (200000) / BHIE_RDDM_DELAY_TIME_US; /* time to enter rddm */
+
+	mhi_log(mhi_dev_ctxt, MHI_MSG_INFO, "Waiting for device to enter RDDM\n");
+	while (rddm_retry--) {
+		cur_exec = mhi_reg_read(bhi_ctxt->bhi_base, BHI_EXECENV);
+		if (cur_exec == MHI_EXEC_ENV_RDDM)
+			break;
+
+		udelay(BHIE_RDDM_DELAY_TIME_US);
+	}
+
+	if (rddm_retry <= 0) {
+		/* This is a hardware reset should gurantee device enter rddm */
+		mhi_log(mhi_dev_ctxt, MHI_MSG_INFO,
+			"Did not enter RDDM triggering host req. reset to force rddm\n");
+		mhi_reg_write(mhi_dev_ctxt, mhi_dev_ctxt->mmio_info.mmio_addr,
+			MHI_SOC_RESET_REQ_OFFSET, MHI_SOC_RESET_REQ);
+	}
+	cur_exec = mhi_reg_read(bhi_ctxt->bhi_base, BHI_EXECENV);
+	mhi_log(mhi_dev_ctxt, MHI_MSG_INFO,
+		"Waiting for image download completion, current EE:%x\n", cur_exec);
+	/* End of of patch-2 */
+}
+#endif
+
 	i = 0;
 	while (timeout--) {
 		cur_exec = mhi_reg_read(bhi_ctxt->bhi_base, BHI_EXECENV);
@@ -692,6 +721,46 @@ int bhi_probe(struct mhi_device_ctxt *mhi_dev_ctxt)
 					rddm_table->bhie_mem_info[i].phys_addr;
 				sg_dma_len(itr) = size;
 			}
+
+#ifdef CONFIG_CNSS_QCA6390
+			/* Patch from MSM gerrit#2559248 */
+			if (mhi_dev_ctxt->core.bar0_base) {
+				u32 pcie_word_val = 0;
+				void __iomem *bhi_base;
+				u32 bhie_off;
+
+				bhi_base = mhi_dev_ctxt->core.bar0_base;
+				pcie_word_val = mhi_reg_read(bhi_base, BHIOFF);
+
+				/* confirm it's a valid reading */
+				if (unlikely(pcie_word_val == U32_MAX)) {
+					mhi_log(mhi_dev_ctxt, MHI_MSG_ERROR,
+						"Invalid BHI Offset:0x%x\n", pcie_word_val);
+					return -EIO;
+				}
+				bhi_base += pcie_word_val;
+
+				pr_err("patch-1: clear rx-vec, bhi_base as 0x%p", bhi_ctxt->bhi_base);
+				if (bhi_base) {
+					/*
+					 * This controller supports rddm, we need to manually clear
+					 * BHIE RX registers since por values are undefined.
+					 */
+					bhie_off = mhi_reg_read(bhi_base, BHIE_OFFSET);
+					if (unlikely(bhie_off == U32_MAX)) {
+						pr_err("Error getting bhie offset\n");
+						/* TODO: goto bhie_error as MSM to avoid memory leak */
+						return -1;
+					}
+
+					/* clear all BHIE rxvec register space */
+					memset_io(bhi_base + BHIE_RXVECADDR_LOW_OFFS,
+							0, BHIE_RXVECSTATUS_OFFS - BHIE_RXVECADDR_LOW_OFFS + 4);
+				} else {
+					pr_err("patch-1: bhi_base not initialized, ignore patch-1");
+				}
+			}
+#endif
 		} else {
 			/* out of memory for rddm, not fatal error */
 			mhi_log(mhi_dev_ctxt, MHI_MSG_INFO,
diff --git a/mhi/mhi_isr.c b/mhi/mhi_isr.c
index b3ca90b..74f5ef2 100755
--- a/mhi/mhi_isr.c
+++ b/mhi/mhi_isr.c
@@ -258,6 +258,17 @@ void mhi_ev_task(unsigned long data)
 
 	mhi_log(mhi_dev_ctxt, MHI_MSG_VERBOSE, "Enter\n");
 
+#ifdef CONFIG_CNSS_QCA6390
+	/* Patch from MSM as gerrit#2559252 */
+	/*
+	 * we can check pm_state w/o a lock here because there is no way
+	 * pm_state can change from reg access valid to no access while this
+	 * therad being executed.
+	 */
+	if (!MHI_REG_ACCESS_VALID(mhi_dev_ctxt->mhi_pm_state))
+		return;
+#endif
+
 	/* Process event ring */
 	ret = mhi_process_event_ring(mhi_dev_ctxt, ev_index, U32_MAX);
 	/*
@@ -271,6 +282,7 @@ void mhi_ev_task(unsigned long data)
 
 		read_lock_bh(&mhi_dev_ctxt->pm_xfer_lock);
 #ifndef CONFIG_CNSS_QCA6390
+		/* Patch from MSM as gerrit#2559252 */
 		if (MHI_REG_ACCESS_VALID(mhi_dev_ctxt->mhi_pm_state))
 #endif
 			in_sys_err = mhi_in_sys_err(mhi_dev_ctxt);
diff --git a/mhi/mhi_pm.c b/mhi/mhi_pm.c
index ccfff84..69f3aa2 100755
--- a/mhi/mhi_pm.c
+++ b/mhi/mhi_pm.c
@@ -187,6 +187,36 @@ static int mhi_pm_initiate_m0(struct mhi_device_ctxt *mhi_dev_ctxt)
 	if (!r || mhi_dev_ctxt->mhi_pm_state == MHI_PM_LD_ERR_FATAL_DETECT) {
 		mhi_log(mhi_dev_ctxt, MHI_MSG_ERROR,
 			"Failed to get M0 event, timeout or LD\n");
+#ifdef CONFIG_CNSS_QCA6390
+		/* Patch from MSM as gerrit#2559252 */
+		/*
+		 * It's possible device already in error state and we didn't
+		 * process it due to low power mode, force a check
+		 */
+		{
+				enum MHI_PM_STATE new_state;
+				unsigned long flags;
+				enum MHI_STATE state = MHI_STATE_LIMIT;
+
+				mhi_log(mhi_dev_ctxt, MHI_MSG_INFO,
+					"MHI System Error Detected\n");
+				write_lock_irqsave(&mhi_dev_ctxt->pm_xfer_lock,
+						   flags);
+				if (MHI_REG_ACCESS_VALID(mhi_dev_ctxt->mhi_pm_state))
+					state = mhi_get_m_state(mhi_dev_ctxt);
+
+				if (state == MHI_STATE_SYS_ERR)
+					new_state = mhi_tryset_pm_state
+						(mhi_dev_ctxt, MHI_PM_SYS_ERR_DETECT);
+				write_unlock_irqrestore
+					(&mhi_dev_ctxt->pm_xfer_lock, flags);
+
+				if (new_state == MHI_PM_SYS_ERR_DETECT)
+					schedule_work(&mhi_dev_ctxt->
+						      process_sys_err_worker);
+		}
+		//mhi_intvec_threaded_handlr(0, mhi_cntrl);
+#endif
 		r = -EIO;
 	} else
 		r = 0;
@@ -624,6 +654,12 @@ int mhi_pm_control_device(struct mhi_device *mhi_device, enum mhi_dev_ctrl ctrl)
 		mhi_pm_slave_mode_power_off(mhi_dev_ctxt);
 		break;
 	case MHI_DEV_CTRL_TRIGGER_RDDM:
+
+#ifdef CONFIG_CNSS_QCA6390
+		/* Patch from MSM gerrit#2559251, blinkly awake, should no side effect */
+		mhi_dev_ctxt->runtime_get(mhi_dev_ctxt);
+		mhi_dev_ctxt->runtime_put(mhi_dev_ctxt);
+#endif
 		write_lock_irqsave(&mhi_dev_ctxt->pm_xfer_lock, flags);
 		if (!MHI_REG_ACCESS_VALID(mhi_dev_ctxt->mhi_pm_state)) {
 			write_unlock_irqrestore(&mhi_dev_ctxt->pm_xfer_lock,
-- 
1.9.1

